Index: issm/trunk/src/c/classes/matrix/ElementMatrix.cpp
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/matrix/ElementMatrix.cpp	(revision 26744)
@@ -21,22 +21,7 @@
 
 	this->nrows=0;
-	this->ncols=0;
 	this->values=NULL;
-	this->dofsymmetrical=false;
-
-	this->row_fsize=0;
-	this->row_flocaldoflist=NULL;
-	this->row_fglobaldoflist=NULL;
-	this->row_ssize=0;
-	this->row_slocaldoflist=NULL;
-	this->row_sglobaldoflist=NULL;
-
-	this->col_fsize=0;
-	this->col_flocaldoflist=NULL;
-	this->col_fglobaldoflist=NULL;
-	this->col_ssize=0;
-	this->col_slocaldoflist=NULL;
-	this->col_sglobaldoflist=NULL;
-
+	this->fglobaldoflist=NULL;
+	this->sglobaldoflist=NULL;
 }
 /*}}}*/
@@ -52,7 +37,4 @@
 	/*intermediaries*/
 	int i,j,counter;
-	int gsize,fsize,ssize;
-	int* P=NULL;
-	bool found;
 
 	/*If one of the two matrix is NULL, we copy the other one*/
@@ -70,13 +52,12 @@
 
 	/*General Case: Ke1 and Ke2 are not empty*/
-	if(!Ke1->dofsymmetrical || !Ke2->dofsymmetrical) _error_("merging 2 non dofsymmetrical matrices not implemented yet");
 
 	/*Initialize itransformation matrix Ke[P[i]] = Ke2[i]*/
-	P=xNew<int>(Ke2->nrows);
+	int* P=xNew<int>(Ke2->nrows);
 
 	/*1: Get the new numbering of Ke2 and get size of the new matrix*/
-	gsize=Ke1->nrows;
+	int gsize=Ke1->nrows;
 	for(i=0;i<Ke2->nrows;i++){
-		found=false;
+		bool found=false;
 		for(j=0;j<Ke1->nrows;j++){
 			if(Ke2->gglobaldoflist[i]==Ke1->gglobaldoflist[j]){
@@ -91,84 +72,26 @@
 	/*2: Initialize static fields*/
 	this->nrows=gsize;
-	this->ncols=gsize;
-	this->dofsymmetrical=true;
 
 	/*Gset and values*/
 	this->gglobaldoflist=xNew<int>(this->nrows);
-	this->values=xNewZeroInit<IssmDouble>(this->nrows*this->ncols);
+	this->fglobaldoflist=xNew<int>(this->nrows);
+	this->sglobaldoflist=xNew<int>(this->nrows);
+	this->values=xNewZeroInit<IssmDouble>(this->nrows*this->nrows);
 	for(i=0;i<Ke1->nrows;i++){
-		for(j=0;j<Ke1->ncols;j++){
-			this->values[i*this->ncols+j] += Ke1->values[i*Ke1->ncols+j];
+		for(j=0;j<Ke1->nrows;j++){
+			this->values[i*this->nrows+j] += Ke1->values[i*Ke1->nrows+j];
 		}
 		this->gglobaldoflist[i]=Ke1->gglobaldoflist[i];
+		this->fglobaldoflist[i]=Ke1->fglobaldoflist[i];
+		this->sglobaldoflist[i]=Ke1->sglobaldoflist[i];
 	}
 	for(i=0;i<Ke2->nrows;i++){
-		for(j=0;j<Ke2->ncols;j++){
-			this->values[P[i]*this->ncols+P[j]] += Ke2->values[i*Ke2->ncols+j];
+		for(j=0;j<Ke2->nrows;j++){
+			this->values[P[i]*this->nrows+P[j]] += Ke2->values[i*Ke2->nrows+j];
 		}
 		this->gglobaldoflist[P[i]]=Ke2->gglobaldoflist[i];
-	}
-
-	/*Fset*/
-	fsize=Ke1->row_fsize;
-	for(i=0;i<Ke2->row_fsize;i++){
-		if(P[Ke2->row_flocaldoflist[i]] >= Ke1->nrows) fsize++;
-	}
-	this->row_fsize=fsize;
-	if(fsize){
-		this->row_flocaldoflist =xNew<int>(fsize);
-		this->row_fglobaldoflist=xNew<int>(fsize);
-		for(i=0;i<Ke1->row_fsize;i++){
-			this->row_flocaldoflist[i] =Ke1->row_flocaldoflist[i];
-			this->row_fglobaldoflist[i]=Ke1->row_fglobaldoflist[i];
-		}
-		counter=Ke1->row_fsize;
-		for(i=0;i<Ke2->row_fsize;i++){
-			if(P[Ke2->row_flocaldoflist[i]] >= Ke1->nrows){
-				this->row_flocaldoflist[counter] =P[Ke2->row_flocaldoflist[i]];
-				this->row_fglobaldoflist[counter]=Ke2->row_fglobaldoflist[i];
-				counter++;
-			}
-		}
-	}
-	else{
-		this->row_flocaldoflist=NULL;
-		this->row_fglobaldoflist=NULL;
-	}
-
-	/*Sset*/
-	ssize=Ke1->row_ssize;
-	for(i=0;i<Ke2->row_ssize;i++){
-		if(P[Ke2->row_slocaldoflist[i]] >= Ke1->nrows) ssize++;
-	}
-	this->row_ssize=ssize;
-	if(ssize){
-		this->row_slocaldoflist =xNew<int>(ssize);
-		this->row_sglobaldoflist=xNew<int>(ssize);
-		for(i=0;i<Ke1->row_ssize;i++){
-			this->row_slocaldoflist[i] =Ke1->row_slocaldoflist[i];
-			this->row_sglobaldoflist[i]=Ke1->row_sglobaldoflist[i];
-		}
-		counter=Ke1->row_ssize;
-		for(i=0;i<Ke2->row_ssize;i++){
-			if(P[Ke2->row_slocaldoflist[i]] >= Ke1->nrows){
-				this->row_slocaldoflist[counter] =P[Ke2->row_slocaldoflist[i]];
-				this->row_sglobaldoflist[counter]=Ke2->row_sglobaldoflist[i];
-				counter++;
-			}
-		}
-	}
-	else{
-		this->row_slocaldoflist=NULL;
-		this->row_sglobaldoflist=NULL;
-	}
-
-	/*don't do cols, we can pick them up from the rows: */
-	this->col_fsize=0;
-	this->col_flocaldoflist=NULL;
-	this->col_fglobaldoflist=NULL;
-	this->col_ssize=0;
-	this->col_slocaldoflist=NULL;
-	this->col_sglobaldoflist=NULL;
+		this->fglobaldoflist[P[i]]=Ke2->fglobaldoflist[i];
+		this->sglobaldoflist[P[i]]=Ke2->sglobaldoflist[i];
+	}
 
 	/*clean-up*/
@@ -193,29 +116,12 @@
 
 	/*get Matrix size and properties*/
-	this->dofsymmetrical=true;
 	this->nrows=GetNumberOfDofs(nodes,numnodes,GsetEnum,approximation);
-	this->ncols=this->nrows;
 
 	/*fill values with 0: */
-	this->values=xNewZeroInit<IssmDouble>(this->nrows*this->ncols);
-
-	/*g list*/
+	this->values=xNewZeroInit<IssmDouble>(this->nrows*this->nrows);
+
 	this->gglobaldoflist=GetGlobalDofList(nodes,numnodes,GsetEnum,approximation);
-
-	/*get dof lists for f and s set: */
-	this->row_fsize=GetNumberOfDofs(nodes,numnodes,FsetEnum,approximation);
-	this->row_flocaldoflist =GetLocalDofList( nodes,numnodes,FsetEnum,approximation);
-	this->row_fglobaldoflist=GetGlobalDofList(nodes,numnodes,FsetEnum,approximation);
-	this->row_ssize=GetNumberOfDofs(nodes,numnodes,SsetEnum,approximation);
-	this->row_slocaldoflist =GetLocalDofList( nodes,numnodes,SsetEnum,approximation);
-	this->row_sglobaldoflist=GetGlobalDofList(nodes,numnodes,SsetEnum,approximation);
-
-	/*Because this matrix is "dofsymmetrical" don't do cols, we can pick them up from the rows: */
-	this->col_fsize=0;
-	this->col_flocaldoflist=NULL;
-	this->col_fglobaldoflist=NULL;
-	this->col_ssize=0;
-	this->col_slocaldoflist=NULL;
-	this->col_sglobaldoflist=NULL;
+	this->fglobaldoflist=GetGlobalDofList(nodes,numnodes,FsetEnum,approximation);
+	this->sglobaldoflist=GetGlobalDofList(nodes,numnodes,SsetEnum,approximation);
 }
 /*}}}*/
@@ -224,12 +130,6 @@
 	xDelete<IssmDouble>(this->values);
 	xDelete<int>(this->gglobaldoflist);
-	xDelete<int>(this->row_flocaldoflist);
-	xDelete<int>(this->row_fglobaldoflist);
-	xDelete<int>(this->row_slocaldoflist);
-	xDelete<int>(this->row_sglobaldoflist);
-	xDelete<int>(this->col_flocaldoflist);
-	xDelete<int>(this->col_fglobaldoflist);
-	xDelete<int>(this->col_slocaldoflist);
-	xDelete<int>(this->col_sglobaldoflist);
+	xDelete<int>(this->fglobaldoflist);
+	xDelete<int>(this->sglobaldoflist);
 }
 /*}}}*/
@@ -246,23 +146,22 @@
 	this->CheckConsistency();
 
-	if(this->dofsymmetrical){
-		/*only use row dofs to add values into global matrices: */
-
-		if(this->row_fsize){
-			/*first, retrieve values that are in the f-set from the g-set values matrix: */
-			localvalues=xNew<IssmDouble>(this->row_fsize);
-			for(int i=0;i<this->row_fsize;i++){
-				localvalues[i] = this->values[this->ncols*this->row_flocaldoflist[i]+ this->row_flocaldoflist[i]];
-			}
-
-			/*add local values into global  matrix, using the fglobaldoflist: */
-			pf->SetValues(this->row_fsize,this->row_fglobaldoflist,localvalues,ADD_VAL);
-
-			/*Free ressources:*/
-			xDelete<IssmDouble>(localvalues);
-		}
-	}
-	else{
-		_error_("non dofsymmetrical matrix AddToGlobal routine not support yet!");
+	/*do we have any component in the F set?*/
+	int fsize = 0;
+	for(int i=0;i<this->nrows;i++){
+		if(this->fglobaldoflist[i]>=0) fsize++;
+	}
+
+	if(fsize){
+		/*first, retrieve values that are in the f-set from the g-set values matrix: */
+		localvalues=xNew<IssmDouble>(this->nrows);
+		for(int i=0;i<this->nrows;i++){
+			localvalues[i] = this->values[this->nrows*i + i];
+		}
+
+		/*add local values into global  matrix, using the fglobaldoflist: */
+		pf->SetValues(fsize,this->fglobaldoflist,localvalues,ADD_VAL);
+
+		/*Free ressources:*/
+		xDelete<IssmDouble>(localvalues);
 	}
 
@@ -270,7 +169,4 @@
 /*}}}*/
 void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
-
-	int i,j;
-	IssmDouble* localvalues=NULL;
 
 	/*Check that Kff has been alocated in debugging mode*/
@@ -286,48 +182,27 @@
 	this->CheckConsistency();
 
-	if(this->dofsymmetrical){
-		/*only use row dofs to add values into global matrices: */
-
-		if(this->row_fsize){
-			/*first, retrieve values that are in the f-set from the g-set values matrix: */
-			localvalues=xNew<IssmDouble>(this->row_fsize*this->row_fsize);
-			for(i=0;i<this->row_fsize;i++){
-				for(j=0;j<this->row_fsize;j++){
-					localvalues[this->row_fsize*i+j]=this->values[this->ncols*this->row_flocaldoflist[i]+this->row_flocaldoflist[j]];
-				}
-			}
-
-			/*add local values into global  matrix, using the fglobaldoflist: */
-			Kff->SetValues(this->row_fsize,this->row_fglobaldoflist,this->row_fsize,this->row_fglobaldoflist,localvalues,ADD_VAL);
-
-			/*Free ressources:*/
-			xDelete<IssmDouble>(localvalues);
-		}
-
-		if((this->row_ssize!=0) && (this->row_fsize!=0)){
-			/*first, retrieve values that are in the f and s-set from the g-set values matrix: */
-			localvalues=xNew<IssmDouble>(this->row_fsize*this->row_ssize);
-			for(i=0;i<this->row_fsize;i++){
-				for(j=0;j<this->row_ssize;j++){
-					localvalues[this->row_ssize*i+j]=this->values[this->ncols*this->row_flocaldoflist[i]+this->row_slocaldoflist[j]];
-				}
-			}
-			/*add local values into global  matrix, using the fglobaldoflist: */
-			Kfs->SetValues(this->row_fsize,this->row_fglobaldoflist,this->row_ssize,this->row_sglobaldoflist,localvalues,ADD_VAL);
-
-			/*Free ressources:*/
-			xDelete<IssmDouble>(localvalues);
-		}
-	}
-	else{
-		_error_("non dofsymmetrical matrix AddToGlobal routine not support yet!");
-	}
-
+	/*do we have any component in the F or S set?*/
+   bool is_fset= false;
+	bool is_sset= false;
+   for(int i=0;i<this->nrows;i++){
+      if(this->fglobaldoflist[i]>=0){
+         is_fset = true;
+      }
+		else{
+			_assert_(this->sglobaldoflist[i]>=0);
+			is_sset = true;
+		}
+   }
+
+	/*only use row dofs to add values into global matrices: */
+	if(is_fset){
+		Kff->SetValues(this->nrows,this->fglobaldoflist,this->nrows,this->fglobaldoflist,this->values,ADD_VAL);
+	}
+	if(is_fset && is_sset){
+		Kfs->SetValues(this->nrows,this->fglobaldoflist,this->nrows,this->sglobaldoflist,this->values,ADD_VAL);
+	}
 }
 /*}}}*/
 void ElementMatrix::AddToGlobal(Matrix<IssmDouble>* Jff){/*{{{*/
-
-	int i,j;
-	IssmDouble* localvalues=NULL;
 
 	/*Check that Jff is not NULL*/
@@ -337,27 +212,16 @@
 	this->CheckConsistency();
 
-	if(this->dofsymmetrical){
-		/*only use row dofs to add values into global matrices: */
-
-		if(this->row_fsize){
-			/*first, retrieve values that are in the f-set from the g-set values matrix: */
-			localvalues=xNew<IssmDouble>(this->row_fsize*this->row_fsize);
-			for(i=0;i<this->row_fsize;i++){
-				for(j=0;j<this->row_fsize;j++){
-					*(localvalues+this->row_fsize*i+j)=*(this->values+this->ncols*this->row_flocaldoflist[i]+this->row_flocaldoflist[j]);
-				}
-			}
-			/*add local values into global  matrix, using the fglobaldoflist: */
-			Jff->SetValues(this->row_fsize,this->row_fglobaldoflist,this->row_fsize,this->row_fglobaldoflist,localvalues,ADD_VAL);
-
-			/*Free ressources:*/
-			xDelete<IssmDouble>(localvalues);
-		}
-
-	}
-	else{
-		_error_("non dofsymmetrical matrix AddToGlobal routine not support yet!");
-	}
-
+	/*do we have any component in the F set?*/
+	bool isfset= false;
+	for(int i=0;i<this->nrows;i++){
+		if(this->fglobaldoflist[i]>=0){
+			isfset = true;
+			break;
+		}
+   }
+
+	if(isfset){
+		Jff->SetValues(this->nrows,this->fglobaldoflist,this->nrows,this->fglobaldoflist,this->values,ADD_VAL);
+	}
 }
 /*}}}*/
@@ -366,8 +230,8 @@
 	#ifdef _ISSM_DEBUG_ 
 	for (int i=0;i<this->nrows;i++){
-		for(int j=0;j<this->ncols;j++){
-			if (xIsNan<IssmDouble>(this->values[i*this->ncols+j])) _error_("NaN found in Element Matrix");
-			if (xIsInf<IssmDouble>(this->values[i*this->ncols+j])) _error_("Inf found in Element Matrix");
-			if (fabs(this->values[i*this->ncols+j])>1.e+50) _error_("Element Matrix values exceeds 1.e+50");
+		for(int j=0;j<this->nrows;j++){
+			if (xIsNan<IssmDouble>(this->values[i*this->nrows+j])) _error_("NaN found in Element Matrix");
+			if (xIsInf<IssmDouble>(this->values[i*this->nrows+j])) _error_("Inf found in Element Matrix");
+			if (fabs(this->values[i*this->nrows+j])>1.e+50) _error_("Element Matrix values exceeds 1.e+50");
 		}
 	}
@@ -380,11 +244,9 @@
 	_printf_("Element Matrix echo:\n");
 	_printf_("   nrows: " << this->nrows << "\n");
-	_printf_("   ncols: " << this->ncols << "\n");
-	_printf_("   dofsymmetrical: " << (dofsymmetrical?"true":"false") << "\n");
 
 	_printf_("   values:\n");
 	for(i=0;i<nrows;i++){
 		_printf_(setw(4) << right << i << ": ");
-		for(j=0;j<ncols;j++) _printf_( " " << setw(11) << setprecision (5) << right << values[i*ncols+j]);
+		for(j=0;j<nrows;j++) _printf_( " " << setw(11) << setprecision (5) << right << values[i*nrows+j]);
 		_printf_("\n");
 	}
@@ -393,29 +255,9 @@
 	if(gglobaldoflist) for(i=0;i<nrows;i++) _printf_(" " << gglobaldoflist[i]); _printf_("\n");
 
-	_printf_("   row_fsize: " << row_fsize << "\n");
-	_printf_("   row_flocaldoflist  (" << row_flocaldoflist << "): ");
-	if(row_flocaldoflist) for(i=0;i<row_fsize;i++) _printf_(" " << row_flocaldoflist[i] ); _printf_(" \n");
-	_printf_("   row_fglobaldoflist  (" << row_fglobaldoflist << "): ");
-	if(row_fglobaldoflist) for(i=0;i<row_fsize;i++)_printf_(" " << row_fglobaldoflist[i]); _printf_(" \n");
-
-	_printf_("   row_ssize: " << row_ssize << "\n");
-	_printf_("   row_slocaldoflist  (" << row_slocaldoflist << "): ");
-	if(row_slocaldoflist) for(i=0;i<row_ssize;i++) _printf_(" " << row_slocaldoflist[i] ); _printf_(" \n");
-	_printf_("   row_sglobaldoflist  (" << row_sglobaldoflist << "): ");
-	if(row_sglobaldoflist) for(i=0;i<row_ssize;i++)_printf_(" " << row_sglobaldoflist[i]); _printf_(" \n");
-
-	if(!dofsymmetrical){
-		_printf_("   col_fsize: " << col_fsize << "\n");
-		_printf_("   col_flocaldoflist  (" << col_flocaldoflist << "): ");
-		if(col_flocaldoflist) for(i=0;i<col_fsize;i++) _printf_(" " << col_flocaldoflist[i] ); _printf_(" \n");
-		_printf_("   col_fglobaldoflist  (" << col_fglobaldoflist << "): ");
-		if(col_fglobaldoflist) for(i=0;i<col_fsize;i++)_printf_(" " << col_fglobaldoflist[i]); _printf_(" \n");
-
-		_printf_("   col_ssize: " << col_ssize << "\n");
-		_printf_("   col_slocaldoflist  (" << col_slocaldoflist << "): ");
-		if(col_slocaldoflist) for(i=0;i<col_ssize;i++) _printf_(" " << col_slocaldoflist[i] ); _printf_(" \n");
-		_printf_("   col_sglobaldoflist  (" << col_sglobaldoflist << "): ");
-		if(col_sglobaldoflist) for(i=0;i<col_ssize;i++)_printf_(" " << col_sglobaldoflist[i]); _printf_(" \n");
-	}
+	_printf_("   fglobaldoflist  (" << fglobaldoflist << "): ");
+	for(i=0;i<nrows;i++)_printf_(" " << fglobaldoflist[i]); _printf_(" \n");
+
+	_printf_("   sglobaldoflist  (" << sglobaldoflist << "): ");
+	for(i=0;i<nrows;i++)_printf_(" " << sglobaldoflist[i]); _printf_(" \n");
 }
 /*}}}*/
@@ -426,71 +268,23 @@
 
 	this->nrows =Ke->nrows;
-	this->ncols =Ke->ncols;
-	this->dofsymmetrical=Ke->dofsymmetrical;
-
-	this->values=xNew<IssmDouble>(this->nrows*this->ncols);
-	xMemCpy<IssmDouble>(this->values,Ke->values,this->nrows*this->ncols);
+
+	this->values=xNew<IssmDouble>(this->nrows*this->nrows);
+	xMemCpy<IssmDouble>(this->values,Ke->values,this->nrows*this->nrows);
 
 	this->gglobaldoflist=xNew<int>(this->nrows);
 	xMemCpy<int>(this->gglobaldoflist,Ke->gglobaldoflist,this->nrows);
-
-	this->row_fsize=Ke->row_fsize;
-	if(this->row_fsize){
-		this->row_flocaldoflist=xNew<int>(this->row_fsize);
-		xMemCpy<int>(this->row_flocaldoflist,Ke->row_flocaldoflist,this->row_fsize);
-		this->row_fglobaldoflist=xNew<int>(this->row_fsize);
-		xMemCpy<int>(this->row_fglobaldoflist,Ke->row_fglobaldoflist,this->row_fsize);
-	}
-	else{
-		this->row_flocaldoflist=NULL;
-		this->row_fglobaldoflist=NULL;
-	}
-
-	this->row_ssize=Ke->row_ssize;
-	if(this->row_ssize){
-		this->row_slocaldoflist=xNew<int>(this->row_ssize);
-		xMemCpy<int>(this->row_slocaldoflist,Ke->row_slocaldoflist,this->row_ssize);
-		this->row_sglobaldoflist=xNew<int>(this->row_ssize);
-		xMemCpy<int>(this->row_sglobaldoflist,Ke->row_sglobaldoflist,this->row_ssize);
-	}
-	else{
-		this->row_slocaldoflist=NULL;
-		this->row_sglobaldoflist=NULL;
-	}
-
-	this->col_fsize=Ke->col_fsize;
-	if(this->col_fsize){
-		this->col_flocaldoflist=xNew<int>(this->col_fsize);
-		xMemCpy<int>(this->col_flocaldoflist,Ke->col_flocaldoflist,this->col_fsize);
-		this->col_fglobaldoflist=xNew<int>(this->col_fsize);
-		xMemCpy<int>(this->col_fglobaldoflist,Ke->col_fglobaldoflist,this->col_fsize);
-	}
-	else{
-		this->col_flocaldoflist=NULL;
-		this->col_fglobaldoflist=NULL;
-	}
-
-	this->col_ssize=Ke->col_ssize;
-	if(this->col_ssize){
-		this->col_slocaldoflist=xNew<int>(this->col_ssize);
-		xMemCpy<int>(this->col_slocaldoflist,Ke->col_slocaldoflist,this->col_ssize);
-		this->col_sglobaldoflist=xNew<int>(this->col_ssize);
-		xMemCpy<int>(this->col_sglobaldoflist,Ke->col_sglobaldoflist,this->col_ssize);
-	}
-	else{
-		this->col_slocaldoflist=NULL;
-		this->col_sglobaldoflist=NULL;
-	}
+	this->fglobaldoflist=xNew<int>(this->nrows);
+	xMemCpy<int>(this->fglobaldoflist,Ke->fglobaldoflist,this->nrows);
+	this->sglobaldoflist=xNew<int>(this->nrows);
+	xMemCpy<int>(this->sglobaldoflist,Ke->sglobaldoflist,this->nrows);
 }
 /*}}}*/
 void ElementMatrix::Lump(void){/*{{{*/
 
-	if(!dofsymmetrical) _error_("not supported yet");
-
 	for(int i=0;i<this->nrows;i++){
-		for(int j=0;j<this->ncols;j++){
+		for(int j=0;j<this->nrows;j++){
 			if(i!=j){
-				this->values[i*this->ncols+i] += this->values[i*this->ncols+j];
-				this->values[i*this->ncols+j]  = 0.;
+				this->values[i*this->nrows+i] += this->values[i*this->nrows+j];
+				this->values[i*this->nrows+j]  = 0.;
 			}
 		}
@@ -505,15 +299,6 @@
 	ElementMatrix* Ke_copy=new ElementMatrix(this);
 
-	/*Update sizes*/
-	this->nrows=Ke_copy->ncols;
-	this->ncols=Ke_copy->nrows;
-
 	/*Transpose values*/
-	for (int i=0;i<this->nrows;i++) for(int j=0;j<this->ncols;j++) this->values[i*this->ncols+j]=Ke_copy->values[j*Ke_copy->ncols+i];
-
-	/*Transpose indices*/
-	if(!dofsymmetrical){
-		_error_("not supported yet");
-	}
+	for (int i=0;i<this->nrows;i++) for(int j=0;j<this->nrows;j++) this->values[i*this->nrows+j]=Ke_copy->values[j*Ke_copy->nrows+i];
 
 	/*Clean up and return*/
@@ -540,5 +325,5 @@
 
 	/*Checks in debugging mode*/
-	_assert_(this->nrows==this->ncols && bsize>0 && bsize<this->ncols && this->values); 
+	_assert_(bsize>0 && bsize<this->nrows && this->values); 
 
 	/*Intermediaries*/
@@ -577,8 +362,8 @@
 	Kbi = xNew<IssmDouble>(bsize*isize);
 	Kbb = xNew<IssmDouble>(bsize*bsize);
-	for(i=0;i<isize;i++) for(j=0;j<isize;j++) Kii[i*isize+j] = this->values[iindices[i]*this->ncols + iindices[j]];
-	for(i=0;i<isize;i++) for(j=0;j<bsize;j++) Kib[i*bsize+j] = this->values[iindices[i]*this->ncols + bindices[j]];
-	for(i=0;i<bsize;i++) for(j=0;j<isize;j++) Kbi[i*isize+j] = this->values[bindices[i]*this->ncols + iindices[j]];
-	for(i=0;i<bsize;i++) for(j=0;j<bsize;j++) Kbb[i*bsize+j] = this->values[bindices[i]*this->ncols + bindices[j]];
+	for(i=0;i<isize;i++) for(j=0;j<isize;j++) Kii[i*isize+j] = this->values[iindices[i]*this->nrows + iindices[j]];
+	for(i=0;i<isize;i++) for(j=0;j<bsize;j++) Kib[i*bsize+j] = this->values[iindices[i]*this->nrows + bindices[j]];
+	for(i=0;i<bsize;i++) for(j=0;j<isize;j++) Kbi[i*isize+j] = this->values[bindices[i]*this->nrows + iindices[j]];
+	for(i=0;i<bsize;i++) for(j=0;j<bsize;j++) Kbb[i*bsize+j] = this->values[bindices[i]*this->nrows + bindices[j]];
 
 	/*Invert Kbb*/
@@ -607,8 +392,8 @@
 
 	/*Update matrix values*/
-	for(i=0;i<this->nrows*this->ncols;i++) this->values[i]=0.;
+	for(i=0;i<this->nrows*this->nrows;i++) this->values[i]=0.;
 	for(i=0;i<isize;i++){
 		for(j=0;j<isize;j++){
-			this->values[iindices[i]*this->ncols + iindices[j]] = Ktemp[i*isize+j];
+			this->values[iindices[i]*this->nrows + iindices[j]] = Ktemp[i*isize+j];
 		}
 	}
Index: issm/trunk/src/c/classes/matrix/ElementMatrix.h
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementMatrix.h	(revision 25994)
+++ issm/trunk/src/c/classes/matrix/ElementMatrix.h	(revision 26744)
@@ -19,33 +19,12 @@
 class ElementMatrix{
 
+	private:
+		int *gglobaldoflist;
+		int *fglobaldoflist;
+		int *sglobaldoflist;
+
 	public:
-
-		int      nrows;
-		int      ncols;
-		bool     dofsymmetrical;
-		IssmDouble*  values;
-
-		//gset
-		int*     gglobaldoflist;
-
-		/*row wise: */
-		//fset
-		int      row_fsize;
-		int*     row_flocaldoflist;
-		int*     row_fglobaldoflist;
-		//sset
-		int      row_ssize;
-		int*     row_slocaldoflist;
-		int*     row_sglobaldoflist;
-
-		/*column wise: */
-		//fset
-		int      col_fsize;
-		int*     col_flocaldoflist;
-		int*     col_fglobaldoflist;
-		//sset
-		int      col_ssize;
-		int*     col_slocaldoflist;
-		int*     col_sglobaldoflist;
+		int         nrows;
+		IssmDouble *values;
 
 		/*ElementMatrix constructors, destructors*/
Index: issm/trunk/src/c/classes/matrix/ElementVector.cpp
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementVector.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/matrix/ElementVector.cpp	(revision 26744)
@@ -22,6 +22,4 @@
 	this->nrows=0;
 	this->values=NULL;
-	this->fsize=0;
-	this->flocaldoflist=NULL;
 	this->fglobaldoflist=NULL;
 
@@ -29,10 +27,4 @@
 /*}}}*/
 ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){/*{{{*/
-
-	/*intermediaries*/
-	int i,j,counter;
-	int gsize,fsize;
-	int* P=NULL;
-	bool found;
 
 	/*If one of the two matrix is NULL, we copy the other one*/
@@ -50,11 +42,11 @@
 
 	/*Initialize itransformation matrix pe[P[i]] = pe2[i]*/
-	P=xNew<int>(pe2->nrows);
+	int* P=xNew<int>(pe2->nrows);
 
 	/*1: Get the new numbering of pe2 and get size of the new matrix*/
-	gsize=pe1->nrows;
-	for(i=0;i<pe2->nrows;i++){
-		found=false;
-		for(j=0;j<pe1->nrows;j++){
+	int gsize=pe1->nrows;
+	for(int i=0;i<pe2->nrows;i++){
+		bool found=false;
+		for(int j=0;j<pe1->nrows;j++){
 			if(pe2->gglobaldoflist[i]==pe1->gglobaldoflist[j]){
 				found=true; P[i]=j; break;
@@ -71,39 +63,15 @@
 	/*Gset and values*/
 	this->gglobaldoflist=xNew<int>(this->nrows);
+	this->fglobaldoflist=xNew<int>(this->nrows);
 	this->values=xNewZeroInit<IssmDouble>(this->nrows);
-	for(i=0;i<pe1->nrows;i++){
+	for(int i=0;i<pe1->nrows;i++){
 		this->values[i] += pe1->values[i];
 		this->gglobaldoflist[i]=pe1->gglobaldoflist[i];
-	}
-	for(i=0;i<pe2->nrows;i++){
+		this->fglobaldoflist[i]=pe1->fglobaldoflist[i];
+	}
+	for(int i=0;i<pe2->nrows;i++){
 		this->values[P[i]] += pe2->values[i];
 		this->gglobaldoflist[P[i]]=pe2->gglobaldoflist[i];
-	}
-
-	/*Fset*/
-	fsize=pe1->fsize;
-	for(i=0;i<pe2->fsize;i++){
-		if(P[pe2->flocaldoflist[i]] >= pe1->nrows) fsize++;
-	}
-	this->fsize=fsize;
-	if(fsize){
-		this->flocaldoflist =xNew<int>(fsize);
-		this->fglobaldoflist=xNew<int>(fsize);
-		for(i=0;i<pe1->fsize;i++){
-			this->flocaldoflist[i] =pe1->flocaldoflist[i];
-			this->fglobaldoflist[i]=pe1->fglobaldoflist[i];
-		}
-		counter=pe1->fsize;
-		for(i=0;i<pe2->fsize;i++){
-			if(P[pe2->flocaldoflist[i]] >= pe1->nrows){
-				this->flocaldoflist[counter] =P[pe2->flocaldoflist[i]];
-				this->fglobaldoflist[counter]=pe2->fglobaldoflist[i];
-				counter++;
-			}
-		}
-	}
-	else{
-		this->flocaldoflist=NULL;
-		this->fglobaldoflist=NULL;
+		this->fglobaldoflist[P[i]]=pe2->fglobaldoflist[i];
 	}
 
@@ -134,18 +102,12 @@
 	this->values=xNewZeroInit<IssmDouble>(this->nrows);
 
-	/*g list*/
+	/*dof list*/
 	this->gglobaldoflist=GetGlobalDofList(nodes,numnodes,GsetEnum,approximation);
-
-	/*Get fsize*/
-	this->fsize=GetNumberOfDofs(nodes,numnodes,FsetEnum,approximation);
-	this->flocaldoflist =GetLocalDofList( nodes,numnodes,FsetEnum,approximation);
 	this->fglobaldoflist=GetGlobalDofList(nodes,numnodes,FsetEnum,approximation);
 }
 /*}}}*/
 ElementVector::~ElementVector(){/*{{{*/
-
 	xDelete<IssmDouble>(this->values);
 	xDelete<int>(this->gglobaldoflist);
-	xDelete<int>(this->flocaldoflist);
 	xDelete<int>(this->fglobaldoflist);
 }
@@ -155,21 +117,18 @@
 void ElementVector::AddToGlobal(Vector<IssmDouble>* pf){/*{{{*/
 
-	int i;
-	IssmDouble* localvalues=NULL;
-
 	/*In debugging mode, check consistency (no NaN, and values not too big)*/
 	this->CheckConsistency();
 
-	if(this->fsize){
-		/*first, retrieve values that are in the f-set from the g-set values vector: */
-		localvalues=xNew<IssmDouble>(this->fsize);
-		for(i=0;i<this->fsize;i++){
-			localvalues[i]=this->values[this->flocaldoflist[i]];
-		}
-		/*add local values into global  vector, using the fglobaldoflist: */
-		pf->SetValues(this->fsize,this->fglobaldoflist,localvalues,ADD_VAL);
-
-		/*Free ressources:*/
-		xDelete<IssmDouble>(localvalues);
+	/*do we have any component in the F set?*/
+	bool isfset= false;
+	for(int i=0;i<this->nrows;i++){
+		if(this->fglobaldoflist[i]>=0){
+			isfset = true;
+			break;
+		}
+	}
+
+	if(isfset){
+		pf->SetValues(this->nrows,this->fglobaldoflist,this->values,ADD_VAL);
 	}
 
@@ -194,7 +153,5 @@
 	_printf_("   nrows: " << nrows << "\n");
 	_printf_("   values:\n");
-	for(i=0;i<nrows;i++){
-		_printf_(setw(4) << right << i << ": " << setw(10) << values[i] << "\n");
-	}
+	for(i=0;i<nrows;i++) _printf_(setw(4) << right << i << ": " << setw(10) << values[i] << "\n");
 
 	_printf_("   gglobaldoflist (" << gglobaldoflist << "): ");
@@ -202,10 +159,6 @@
 	_printf_(" \n");
 
-	_printf_("   fsize: " << fsize << "\n");
-	_printf_("   flocaldoflist  (" << flocaldoflist << "): ");
-	if(flocaldoflist) for(i=0;i<fsize;i++) _printf_(" " << flocaldoflist[i] );
-	_printf_(" \n");
 	_printf_("   fglobaldoflist (" << fglobaldoflist << "): ");
-	if(fglobaldoflist) for(i=0;i<fsize;i++) _printf_(" " << fglobaldoflist[i] );
+	if(fglobaldoflist) for(i=0;i<nrows;i++) _printf_(" " << fglobaldoflist[i] );
 	_printf_(" \n");
 }
@@ -223,33 +176,22 @@
 	xMemCpy<int>(this->gglobaldoflist,pe->gglobaldoflist,this->nrows);
 
-	this->fsize=pe->fsize;
-	if(this->fsize){
-		this->flocaldoflist=xNew<int>(this->fsize);
-		xMemCpy<int>(this->flocaldoflist,pe->flocaldoflist,this->fsize);
-		this->fglobaldoflist=xNew<int>(this->fsize);
-		xMemCpy<int>(this->fglobaldoflist,pe->fglobaldoflist,this->fsize);
-	}
-	else{
-		this->flocaldoflist=NULL;
-		this->fglobaldoflist=NULL;
-	}
+	this->fglobaldoflist=xNew<int>(this->nrows);
+	xMemCpy<int>(this->fglobaldoflist,pe->fglobaldoflist,this->nrows);
 }
 /*}}}*/
 void ElementVector::InsertIntoGlobal(Vector<IssmDouble>* pf){/*{{{*/
 
-	int i;
-	IssmDouble* localvalues=NULL;
-
-	if(this->fsize){
-		/*first, retrieve values that are in the f-set from the g-set values vector: */
-		localvalues=xNew<IssmDouble>(this->fsize);
-		for(i=0;i<this->fsize;i++){
-			localvalues[i]=this->values[this->flocaldoflist[i]];
-		}
+	/*do we have any component in the F set?*/
+	bool isfset= false;
+	for(int i=0;i<this->nrows;i++){
+		if(this->fglobaldoflist[i]>=0){
+			isfset = true;
+			break;
+		}
+	}
+
+	if(isfset){
 		/*add local values into global  vector, using the fglobaldoflist: */
-		pf->SetValues(this->fsize,this->fglobaldoflist,localvalues,INS_VAL);
-
-		/*Free ressources:*/
-		xDelete<IssmDouble>(localvalues);
+		pf->SetValues(this->nrows,this->fglobaldoflist,this->values,INS_VAL);
 	}
 
@@ -258,7 +200,5 @@
 void ElementVector::SetValue(IssmDouble scalar){/*{{{*/
 
-	int i;
-
-	for(i=0;i<this->nrows;i++)this->values[i]=scalar;
+	for(int i=0;i<this->nrows;i++)this->values[i]=scalar;
 
 }
@@ -283,5 +223,5 @@
 	/*Checks in debugging mode*/
 	_assert_(bsize>0 && bsize<this->nrows && this->values && Ke); 
-	_assert_(Ke->nrows==Ke->ncols && this->nrows==Ke->nrows);
+	_assert_(this->nrows==Ke->nrows);
 
 	/*Intermediaries*/
@@ -320,6 +260,6 @@
 	Fb  = xNew<IssmDouble>(bsize);
 	Fi  = xNew<IssmDouble>(isize);
-	for(i=0;i<isize;i++) for(j=0;j<bsize;j++) Kib[i*bsize+j] = Ke->values[iindices[i]*Ke->ncols + bindices[j]];
-	for(i=0;i<bsize;i++) for(j=0;j<bsize;j++) Kbb[i*bsize+j] = Ke->values[bindices[i]*Ke->ncols + bindices[j]];
+	for(i=0;i<isize;i++) for(j=0;j<bsize;j++) Kib[i*bsize+j] = Ke->values[iindices[i]*Ke->nrows + bindices[j]];
+	for(i=0;i<bsize;i++) for(j=0;j<bsize;j++) Kbb[i*bsize+j] = Ke->values[bindices[i]*Ke->nrows + bindices[j]];
 	for(i=0;i<bsize;i++) Fb[i] = this->values[bindices[i]];
 	for(i=0;i<isize;i++) Fi[i] = this->values[iindices[i]];
Index: issm/trunk/src/c/classes/matrix/ElementVector.h
===================================================================
--- issm/trunk/src/c/classes/matrix/ElementVector.h	(revision 25994)
+++ issm/trunk/src/c/classes/matrix/ElementVector.h	(revision 26744)
@@ -20,15 +20,11 @@
 class ElementVector{
 
+	private:
+		int *gglobaldoflist;
+		int *fglobaldoflist;
+
 	public:
 		int         nrows;
-		IssmDouble* values;
-
-		//gset
-		int* gglobaldoflist;
-
-		//fset
-		int  fsize;
-		int* flocaldoflist;
-		int* fglobaldoflist;
+		IssmDouble *values;
 
 		/*ElementVector constructors, destructors*/
Index: issm/trunk/src/c/cores/CorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/cores/CorePointerFromSolutionEnum.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/CorePointerFromSolutionEnum.cpp	(revision 26744)
@@ -1,5 +1,5 @@
 /*!\file:  CorePointerFromSolutionEnum.cpp
  * \brief: return type of analyses, number of analyses and core solution function.
- */ 
+ */
 
 #ifdef HAVE_CONFIG_H
@@ -59,16 +59,9 @@
 			solutioncore=&masstransport_core;
 			break;
-		case SealevelriseSolutionEnum:
-			solutioncore=&sealevelchange_core;
+		case OceantransportSolutionEnum:
+			solutioncore=&oceantransport_core;
 			break;
 		case EsaSolutionEnum:
 			solutioncore=&esa_core;
-			break;
-		case GiaSolutionEnum:
-			#if _HAVE_GIA_
-			solutioncore=&gia_core;
-			#else
-			_error_("ISSM not compiled with Gia capability");
-			#endif
 			break;
 		case DamageEvolutionSolutionEnum:
@@ -82,4 +75,7 @@
 			#endif
 			break;
+		case SamplingSolutionEnum:
+			solutioncore=&sampling_core;
+			break;
 
 		default:
Index: issm/trunk/src/c/cores/WrapperPreCorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/cores/WrapperPreCorePointerFromSolutionEnum.cpp	(revision 26744)
+++ issm/trunk/src/c/cores/WrapperPreCorePointerFromSolutionEnum.cpp	(revision 26744)
@@ -0,0 +1,34 @@
+/*!\file:  WrapperPreCorePointerFromSolutionEnum.cpp
+ * \brief: return solution core that is carried out once only for Dakota runs.
+ */ 
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "./cores.h"
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+#include "../solutionsequences/solutionsequences.h"
+
+void WrapperPreCorePointerFromSolutionEnum(void (**psolutioncore)(FemModel*),Parameters* parameters,int solutiontype){
+
+	/*output: */
+	void (*solutioncore)(FemModel*)=NULL;
+
+	switch(solutiontype){
+
+		case TransientSolutionEnum:
+			solutioncore=&transient_precore;
+			break;
+		default:
+			break;
+	}
+
+	/*Assign output pointer:*/
+	*psolutioncore=solutioncore;
+
+}
Index: issm/trunk/src/c/cores/ad_core.cpp
===================================================================
--- issm/trunk/src/c/cores/ad_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/ad_core.cpp	(revision 26744)
@@ -326,5 +326,12 @@
 
 			/*First, stop tracing: */
+			#if _CODIPACK_MAJOR_==2
+			auto& tape_codi = IssmDouble::getTape();
+			#elif _CODIPACK_MAJOR_==1
 			auto& tape_codi = IssmDouble::getGlobalTape();
+			#else
+			#error "_CODIPACK_MAJOR_ not supported"
+			#endif
+
 			tape_codi.setPassive();
 
